<template>
  <main>
    <v-container>
      <h5 class="headline fw-300 grey--text">Games of the day</h5>
      <v-layout row wrap>
        <v-flex sm12>
          <v-card>
            <v-card-title primary-title>
              <v-layout row fill-height align-center>
                <!-- Main Heading -->
                <v-flex sm7>
                  <h6 class="title fw-400 mb-0">{{currentDate.format('MMMM D, YYYY')}}</h6>
                  <span class="grey--text">Creation Time</span>
                </v-flex>
                <!-- Date Filter -->
                <!-- <v-flex sm5>
                  <v-menu lazy full-width>
                    <v-text-field slot="activator" label="Filter Date" v-model="filterDate" append-icon="filter_list" readonly></v-text-field>
                    <v-date-picker v-model="filterDate"></v-date-picker>
                  </v-menu>
                </v-flex> -->
              </v-layout>
            </v-card-title>
            <!-- Games List -->
            <v-data-table
              :headers="headers"
              :items="games"
              :loading="loading"
              :no-data-text="loading ? 'Loading' : 'No games for this day.'"
              hide-actions>
              <template slot="items" scope="{item}">
                <tr>
                  <td>{{item.duration}}</td>
                  <td>{{$moment.unix(Math.round(item.startTime / 1000)).format('ddd, MMM D, YYYY h:mma')}}</td>
                  <td>{{$moment.unix(Math.round(item.endTime / 1000)).format('ddd, MMM D, YYYY h:mma')}}</td>
                  <td><v-icon>{{item.booked ? 'check_box' : 'check_box_outline_blank'}}</v-icon></td>
                  <td>{{item.price}}</td>
                  <td>{{item.payment_status}}</td>
                </tr>
              </template>
            </v-data-table>
            <!-- Actions -->
            <v-divider></v-divider>
            <v-card-actions>
              <v-btn flat primary to="/games">View All</v-btn>
              <time-slot></time-slot>
            </v-card-actions>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </main>
</template>

<script>
  import TimeSlot from '@/components/games/time-slot'
  export default {
    name: 'dashboard',
    components: {TimeSlot},
    // Module Configuration
    data () {
      return {
        loading: true,
        currentDate: this.$moment(),
        maxResults: 100,
        headers: [
          {text: 'Duration', value: 'duration', align: 'left'},
          {text: 'Start Time', value: 'startTime', align: 'left'},
          {text: 'End Time', value: 'endTime', align: 'left'},
          {text: 'Booked', value: 'booked', align: 'left'},
          {text: 'Price', value: 'price', align: 'left'},
          {text: 'Payment Status', value: 'payment_status', align: 'left'}
        ],
        games: [],
        filterDate: null
      }
    },
    // Config Observer
    watch: {
      filterDate (to, from) {
        this.currentDate = this.$moment(to, 'YYYY-MM-DD')
      }
    },
    // Initialization Block
    created () {
      // Get `games` within the `currentDate`
      this.$database
        .ref('games')
        .orderByChild('startTime')
        /*
         * For `startAt` and `endAt` to work properly, mobile app should store timestamps as integer,
         * currently it is storing as a string. Also in the database, the value is a unix timestamp but
         * in miliseconds (Date.now()). Unix in seconds format is recommended (moment().unix()).
         * As a work arround, `currentDate` will be multiplied by 1000.
         */
        .startAt(this.currentDate.startOf('day').unix() * 1000)
        .endAt(this.currentDate.endOf('day').unix() * 1000)
        .limitToLast(this.maxResults)
        .once('value')
        .then(snapshot => {
          let games = snapshot.val()

          if (games) {
            Object.keys(games).forEach(game => {
              // Check if there is a booked game
              this.$database.ref('game_details').orderByChild('game_id').equalTo(game).once('value').then(snapshot => {
                games[game].key = game
                games[game].booked = !!snapshot.val()
                this.games.push(games[game])
                this.loading = false
              })
            })
          } else this.loading = false
        })
    }
  }
</script>

<style scoped>
  tr:hover {
    cursor: pointer;
  }
</style>
